import React from "react"
import { reducer, initialState } from "./reducer"

import Poll from "./Poll"

export const AppData = React.createContext({
  state: initialState,
  dispatch: () => null
})

export const AppDataProvider = ({ children }) => {

  const [data, dispatchData] = React.useReducer(reducer, initialState)

  const games = Poll('api/gamestate', 30, data.disablePolling)
  const leaderboard = Poll('api/leaderboard', 60, data.disablePolling)
  
  data.games       = games.data
  data.leaderboard = leaderboard.data
  
  var fetching = []
  if (games.fetching === true)
    fetching =  [...fetching, "games"]
  if (leaderboard.fetching === true)
    fetching =  [...fetching, "leaderboard"]
  
  data.fetching = fetching
  
  return (
    <AppData.Provider value={[data, dispatchData]}>
      {children}
    </AppData.Provider>
  )
}
